//////////////
//Datablocks//
//////////////

datablock StaticShapeData(fakeShapeNameShape)
{
	shapeFile = "base/data/shapes/empty.dts";
};

////////////
//Commands//
////////////

function serverCmdSetName(%client, %name1, %name2, %name3)
{
	if(!$LifeRP::Pref::RPNames)
		return;
	
	if(%name1 $= "")
	{
		%client.chatMessage("\c6You forgot to provide a name.");
		return;
	}
	else if(%name2 $= "")
	{
		%client.chatMessage("\c6You forgot to provide a last name.");
		return;
	}
	
	if(strLen(%name1) > 25)
	{
		%client.chatmessage("\c6Your first name is too long. Only 25 characters are allowed.");
		return;
	}
	
	if((%name3 $= "" && strLen(%name2) > 25) || strLen(%name3) > 25)
	{
		%client.chatmessage("\c6Your last name is too long. Only 25 characters are allowed.");
		return;
	}
	
	if(strLen(%name2) > 25)
	{
		%client.chatmessage("\c6Your middle name is too long. Only 25 characters are allowed.");
		return;
	}
	
	if(%name3 $= "")
	{
		$LifeRP_Player[%client.bl_id, "FirstName"] = %name1;
		$LifeRP_Player[%client.bl_id, "MiddleName"] = "";
		$LifeRP_Player[%client.bl_id, "LastName"] = %name2;
		
		%client.chatMessage("\c6Your name is now \c3" @ $LifeRP_Player[%client.bl_id, "FirstName"] SPC $LifeRP_Player[%client.bl_id, "LastName"] @ "\c6.");
		%client.chatMessage("\c6This will be used in official documents and anything of the sort.");
	}
	else
	{
		$LifeRP_Player[%client.bl_id, "FirstName"] = %name1;
		$LifeRP_Player[%client.bl_id, "MiddleName"] = %name2;
		$LifeRP_Player[%client.bl_id, "LastName"] = %name3;
		
		%client.chatMessage("\c6Your name is now \c3" @ $LifeRP_Player[%client.bl_id, "FirstName"] SPC $LifeRP_Player[%client.bl_id, "MiddleName"] SPC $LifeRP_Player[%client.bl_id, "LastName"] @ "\c6.");
		%client.chatMessage("\c6This will be used in official documents and anything of the sort.");
	}
	
	export("$LifeRP_Player" @ %client.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %client.BL_ID @ ".cs");
}

function serverCmdSetNickName(%client, %nick1, %nick2, %nick3, %nick4, %nick5)
{
	if(!$LifeRP::Pref::RPNames)
		return;

	%full = %nick1 SPC %nick2 SPC %nick3 SPC %nick4 SPC %nick5;
	%full = trim(%full);
	
	if(strLen(%full) > 35)
	{
		%client.chatmessage("Your nickname is too long. Only 35 characters are allowed.");
		return;
	}
	
	if(%full !$= "")
	{
		$LifeRP_Player[%client.bl_id, "NickName"] = %full;
		
		%client.chatMessage("\c6Your nickname is now \c3" @ $LifeRP_Player[%client.bl_id, "NickName"] @ "\c6.");
		%client.chatMessage("\c6This will be your visible name when used in casual situations.");
	}
	else
		%client.chatMessage("\c6You forgot to provide a name.");
	
	export("$LifeRP_Player" @ %client.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %client.BL_ID @ ".cs");
}

////////
//Gets//
////////
function gameConnection::LifeRP_GetRPName(%this, %type)
{
	if($LifeRP::Pref::RPNames)
	{
		%type = mfloor(%type);
		%blid = %this.BL_ID;
		%firstName = $LifeRP_Player[%blid, "FirstName"];
		%middleName = $LifeRP_Player[%blid, "MiddleName"];
		%lastName = $LifeRP_Player[%blid, "LastName"];
		%nickName = $LifeRP_Player[%blid, "NickName"];
		
		if(%type <= 0) //nick
		{
			%fullname = %nickName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			
			return %fullname;
		}
		if(%type == 1) //first middle last
		{
			%fullname = %firstName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			else
			{
				if(%middleName $= "")
					%fullname = %fullname SPC %lastName;
				else
					%fullname = %fullname SPC %middleName SPC %lastName;
			}
			
			return %fullname;
		}
		if(%type >= 2) //first "nick" middle last
		{
			%fullname = %firstName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			else
			{
				if(%nickName $= "" || %nickName $= %firstName)
				{
					if(%middleName $= "")
						%fullname = %fullname SPC %lastName;
					else
						%fullname = %fullname SPC %middleName SPC %lastName;
				}
				else
				{
					%fullname = %fullname @ " \"" @ %nickName @ "\"";
					if(%middleName $= "")
						%fullname = %fullname SPC %lastName;
					else
						%fullname = %fullname SPC %middleName SPC %lastName;
				}
			}
			
			return %fullname;
		}
	}
	else
		return %this.name;
}

////////////////////
//Fake Shape Names//
////////////////////

function Player::SetFakePlayerShapeName(%this, %name, %color, %dist, %time)
{
	if(!isObject(%this))
		return;
	
	if(!isObject(%this.tag))
	{
		%this.tag = new StaticShape()
		{
			datablock = fakeShapeNameShape;
			position = %this.getPosition();
		};
	}
	
	%this.tag.setShapeName(%name);
	%this.tag.setShapeNameColor(%color);
	%this.tag.setShapeNameDistance(%dist);
	setFakeShapeName(%this, %this.tag, %time);
}

function setFakeShapeName(%this, %tag, %time)
{
	cancel(%this.fakeTagSchedule);
	if(isObject(%this) && %this.fakeTagTime > 0)
	{
		if(isObject(%tag))
		{
			%pos = %this.getEyeTransform();
			%tag.settransform(%pos);
			%this.fakeTagTime--;
			%this.fakeTagSchedule = schedule(1, 0, setFakeShapeName, %this, %tag, %this.fakeTagTime);
		}
		else
			error("Error: No Shape");
	}
	else
		%tag.delete();
}

function Player::SetFakePlayerChatShapeName(%this, %name, %color, %dist, %time)
{
	if(!isObject(%this))
		return;
	
	if(!isObject(%this.chatTag))
	{
		%this.chatTag = new StaticShape()
		{
			datablock = fakeShapeNameShape;
			position = %this.getPosition();
		};
	}
	
	%this.chatTag.setShapeName(%name);
	%this.chatTag.setShapeNameColor(%color);
	%this.chatTag.setShapeNameDistance(%dist);
	setFakeChatShapeName(%this, %this.chatTag, %time);
}

function setFakeChatShapeName(%this, %tag, %time)
{
	cancel(%this.fakeTagChatSchedule);
	if(isObject(%this) && %this.fakeTagTime > 0)
	{
		if(isObject(%tag))
		{
			%pos = %this.getEyeTransform();
			%pos = vectorAdd(%pos, "0 0 -0.5");
			%tag.settransform(%pos);
			%this.fakeTagTime--;
			%this.fakeTagChatSchedule = schedule(1, 0, setFakeChatShapeName, %this, %tag, %this.fakeTagTime);
		}
		else
			error("Error: No Shape");
	}
	else
		%tag.delete();
}

///////////
//Package//
///////////

if(isPackage(GameModeLifeRPChatPackage))
	deactivatePackage(GameModeLifeRPChatPackage);
package GameModeLifeRPChatPackage
{
	function serverCmdMessageSent(%client, %text)
	{
		if($LifeRP::Pref::RPChat)
		{
			//determine what type of chatting they are doing
			if(%client.isTeamChatting)
			{
				if($LifeRP::Pref::TeamChatIsOOC)
					%client.isOOC = true;
				else
					%client.isOOC = false;
			}
			else
			{
				if($LifeRP::Pref::TeamChatIsOOC)
					%client.isOOC = false;
				else
					%client.isOOC = true;
			}
			
			%player = %client.player;
			if(!isObject(%player)) //this will force chat to be ooc if the player is loading or has died etc
				%client.isOOC = true;
			
			//send to its designated chat type
			if(%client.isOOC)
			{
				%oldPrefix = %client.clanPrefix;
			
				%newPrefix = "\c7(\c4OOC\c7) ";
				
				if($LifeRP::Pref::OOCAdminTags) //very tiny admin tags, i want people to know if the person is an admin but i dont want a giant ego boost.
				{ //please dont make these too flashy if you edit them.
					if(%client.isHost)
						%newPrefix = %newPrefix @ "\c5h ";
					else if(%client.isSuperAdmin)
						%newPrefix = %newPrefix @ "\c2sa ";
					else if(%client.isAdmin)
						%newPrefix = %newPrefix @ "\c2a ";
					else if(%client.isModerator || %client.isMod) //just incase you have a moderator addon
						%newPrefix = %newPrefix @ "\c4m ";
				}
				
				%client.clanPrefix = %newPrefix @ "\c7" @ %oldPrefix;
				parent::serverCmdMessageSent(%client, %text);
				%client.clanPrefix = %oldPrefix;
			}
			else
			{
				%name = %client.LifeRP_GetRPName();
				
				%textAmt = trim(%text);
				%textAmt = strLen(%textAmt);
				if(getSubStr(%text, 0, 1) $= "<")
					%client.isWhispering = true;
				else if(getSubStr(%text, %textAmt - 1, %textAmt) $= "!")
					%client.isShouting = true;
				
				%player.fakeTagTime = mfloor(%textAmt * 50);
				if(%player.fakeTagTime < 500)
					%player.fakeTagTime = 500;
				if(%player.fakeTagTime > 10000)
					%player.fakeTagTime = 10000;
				
				if(%client.isWhispering)
				{
					%range = 1;
					%tagRange = 5;
					%color = "0.8 0.8 0.8 1";
				}
				else if(%client.isShouting)
				{
					%range = 50;
					%tagRange = 55;
					%color = "1 0.8 0.8 1";
				}
				else
				{
					%range = 15;
					%tagRange = 20;
					%color = "1 1 1 1";
				}
				
				%player.SetFakePlayerShapeName(%name, "1 1 0 1", %tagRange, %player.fakeTagTime);
				%player.SetFakePlayerChatShapeName(%text, %color, %tagRange, %player.fakeTagTime);
				
				InitContainerRadiusSearch(%player.position, %range, $TypeMasks::PlayerObjectType);
				while((%target = containerSearchNext()) !$= 0)
				{
					%targetClient = %target.client;
					
					if(isObject(%targetClient))
					{
						if(%target != %player && %target = %targetClient.player)
						{
							%target.fakeTagTime = %player.fakeTagTime;
							
							%target.SetFakePlayerShapeName("!!!", "0 1 1 1", %tagRange, %target.fakeTagTime);
							%target.SetFakePlayerChatShapeName(" ", %color, %tagRange, %player.fakeTagTime);
						}
					
						if(%client.isWhispering)
							%targetClient.chatMessage("\c3" @ %name @ "<color:dddddd>: " @ %text);
						else if(%client.isShouting)
							%targetClient.chatMessage("\c3" @ %name @ "<color:ffdddd>: " @ %text);
						else
							%targetClient.chatMessage("\c3" @ %name @ "\c6: " @ %text);
					}
				}
				
				echo("(" @ %client.name @ ") " @ %name @ ": " @ %text);
			}
			
			//tell player there is an rp chat system
			if($LifeRP::Pref::TeamChatIsOOC)
			{
				if(mfloor(%client.knowsOOCChat) <= 0)
				{
					%client.chatMessage("\c6Once ingame, you must use team chat, default \"Y\", to talk OOC!");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 1)
				{
					%client.chatMessage("\c6Yeah, talk into team chat, default \"Y\", to talk Out Of Character!");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 2)
				{
					%client.chatMessage("\c6I hope you know to talk into team chat, default \"Y\", to talk OOC! This is the last I'll tell you! Have fun!");
					%client.knowsOOCChat++;
				}
			}
			else if(!$LifeRP::Pref::TeamChatIsOOC)
			{
				if(mfloor(%client.knowsOOCChat) <= 0)
				{
					%client.chatMessage("\c6Once ingame, you must use team chat, default \"Y\", to talk in RP chat!");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 1)
				{
					%client.chatMessage("\c6Yeah, talk into team chat, default \"Y\", to talk in RolePlay Chat!");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 2)
				{
					%client.chatMessage("\c6I hope you know to talk into team chat, default \"Y\", to talk in RP chat! This is the last I'll tell you! Have fun!");
					%client.knowsOOCChat++;
				}
			}
			
			%client.isShouting = false;
			%client.isWhispering = false;
			%client.isOOC = false;
		}
		else
			parent::serverCmdMessageSent(%client, %text);
	}
	
	function serverCmdTeamMessageSent(%client, %text)
	{
		if($LifeRP::Pref::RPChat)
		{
			%client.isTeamChatting = true;
			serverCmdMessageSent(%client, %text);
			%client.isTeamChatting = false;
		}
		else
			parent::serverCmdTeamMessageSent(%client, %text);
	}
	
	function player::setShapeNameDistance(%this, %dist)
	{
		if($LifeRP::Pref::RPChat)
			%dist = 0;
		
		parent::setShapeNameDistance(%this, %dist);
	}
	
	//fake shape name stuff
	function MiniGameSO::reset(%this, %client)
	{
		for(%i = 0; %i < missionCleanup.getCount(); %i++)
		{
			%obj = missionCleanup.getObject(%i);
			if(%obj.getClassName() $= "StaticShape")
			{
				if(%obj.getDatablock() == fakeShapeNameShape.getID())
					%obj.delete();
			}
		}
		Parent::reset(%this, %client);
	}
};
activatePackage(GameModeLifeRPChatPackage);