//////////////
//Datablocks//
//////////////

datablock fxDtsBrickData(BrickLifeRPPrisonSpawnData : BrickSpawnPointData)
{
	uiName = "Prison Spawn";
	LifeRP_AdminOnly = true;
};

datablock PlayerData(LifeRP_IncapacitatedPlayerArmor : PlayerNoJet)
{
	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;
	jumpforce = 0;
	uiName = 'Incapacitated Player';
};

///////////////
//Crime Units//
///////////////

function gameConnection::LifeRP_AddCrime(%this, %amount, %message)
{
	%amount = mfloor(%amount);
	
	if(%amount == 0)
		return;
	
	if(%message !$= "")
		%message = "\c7[\c3" @ %message @ "\c7]";
	
	$LifeRP_Player[%this.bl_id, "Crime"] += %amount;
	$LifeRP_Player[%this.bl_id, "Crime"] = mfloor($LifeRP_Player[%this.bl_id, "Crime"]);
	
	if(mfloor($LifeRP_Player[%this.bl_id, "Jail"]) > 0)
	{
		%timeJail = mfloor(%amount / 10);
		
		if(%timeJail > 1)
			%this.centerPrint("\c0You have commited a crime.<br>" @ %message @ "<br>\c0You will be in prison for " @ %timeJail @ " more hours if you are discovered.", 10);
		else if(%timeJail == 1)
			%this.centerPrint("\c0You have commited a crime.<br>" @ %message @ "<br>\c0You will be in prison for " @ %timeJail @ " more hour if you are discovered.", 10);
	}
	else
	{
		if(%amount > 1)
			%this.centerPrint("\c0You have commited a crime.<br>" @ %message @ "<br>\c0+" @ %amount SPC $LifeRP::Pref::CrimeNamePlural @ ".", 10);
		else if(%amount == 1)
			%this.centerPrint("\c0You have commited a crime.<br>" @ %message @ "<br>\c0+" @ %amount SPC $LifeRP::Pref::CrimeNameSingle @ ".", 10);
	}
	
	if(mfloor($LifeRP_Player[%this.bl_id, "Crime"]) <= 0)
		deleteVariables("$LifeRP_Player" @ %this.bl_id @ "_Crime");
	
	%this.LifeRP_applyHud();
	export("$LifeRP_Player" @ %this.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %this.BL_ID @ ".cs");
}

function fxDtsBrick::LifeRP_checkHasCrime(%this, %amount, %client)
{
	if(!isObject(%client.player))
		return;
	
	%player = %client.player;
	if(!%player.getClassName() $= "Player")
		return;

	$InputTarget_["Self"] = %this;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %client;

	if(getMiniGameFromObject(%this) == getMiniGameFromObject(%client))
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%this);
	else
		$InputTarget_["MiniGame"] = 0;

	if(mfloor($LifeRP_Player[%client.bl_id, "Crime"]) >= %amount)
	{
		%this.processInputEvent(onLifeRPCrimeCheckPass, %client);
		return;
	}
	
	%this.processInputEvent(onLifeRPCrimeCheckFail, %client);
}

////////
//Jail//
////////

function gameConnection::LifeRP_Jail(%this)
{
	%crime = mfloor($LifeRP_Player[%this.bl_id, "Crime"]);
	%timeJail = mfloor(%crime / 10);

	if(mfloor($LifeRP_Player[%this.bl_id, "Jail"]) > 0 && %crime >= 10)
		messageAll('', "\c3" @ %this.LifeRP_GetRPName() @ "\c6 was arrested in " @ $LifeRP::Pref::JailName @ "! They'll be in for " @ %timeJail @ " more hours.");
	else if(%crime >= 240)
		messageAll('', "\c3" @ %this.LifeRP_GetRPName() @ "\c6 was arrested! They'll be in " @ $LifeRP::Pref::JailName @ " for " @ %timeJail @ " hours.");
	else
		return;
	
	$LifeRP_Player[%this.bl_id, "Jail"] += %crime;
	$LifeRP_Player[%this.bl_id, "Crime"] = 0;
	serverCmdClearCheckpoint(%this);
	%this.spawnPlayer();
}

function fxDtsBrick::LifeRP_checkInJail(%this, %client)
{
	if(!isObject(%client.player))
		return;
	
	%player = %client.player;
	if(!%player.getClassName() $= "Player")
		return;

	$InputTarget_["Self"] = %this;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %client;

	if(getMiniGameFromObject(%this) == getMiniGameFromObject(%client))
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%this);
	else
		$InputTarget_["MiniGame"] = 0;

	if(mfloor($LifeRP_Player[%client.bl_id, "Jail"]) > 0)
	{
		%this.processInputEvent(onLifeRPInJailCheckPass, %client);
		return;
	}
	
	%this.processInputEvent(onLifeRPInJailCheckFail, %client);
}

/////////////////
//Incapacitated//
/////////////////

function gameConnection::incapacitate(%this, %player, %health)
{
	%player.changeDatablock(LifeRP_IncapacitatedPlayerArmor);
	%player.setHealth(%health);
	%player.playThread(0, death1);
	
	if(%player.isIncapacitated == true)
		return;
	
	%player.isIncapacitated = true;
	%this.centerPrint("You've been incapacitated!", 3);
	
	incapacitatedTick(%player);
}

function incapacitatedTick(%player)
{
	%player.addhealth(1);
	
	%health = %player.getdatablock().maxdamage - %player.getdamagelevel();
	
	if(mfloor(%health) >= 100)
	{
		%player.changeDatablock(PlayerNoJet);
		%player.setHealth(%health);
		%player.playThread(0, root);
		%player.isIncapacitated = false;
		%player.client.centerPrint("\c3You can now move.", 3);
		return;
	}
	
	schedule(1000, %player, incapacitatedTick, %player);
}

///////////
//Package//
///////////

if(isPackage(GameModeLifeRPCrimePackage))
	deactivatePackage(GameModeLifeRPCrimePackage);
package GameModeLifeRPCrimePackage
{
	function HammerImage::onHitObject(%this, %player, %slot, %col, %pos, %normal)
	{
		if(%col.getClassName() $= "Player" && isObject(%col.client))
		{
			if(%col.getDataBlock().getID() != LifeRP_IncapacitatedPlayerArmor.getID() && !%col.isIncapacitated)
			{
				%col.client.incapacitate(%col, 95);
				return;
			}
			
			if(mfloor($LifeRP_Player[%col.client.bl_id, "Jail"]) > 0 && mfloor($LifeRP_Player[%col.client.bl_id, "Crime"]) >= 10)
				%col.client.LifeRP_Jail(); //temporary solution
			else if(mfloor($LifeRP_Player[%col.client.bl_id, "Crime"]) >= 240)
				%col.client.LifeRP_Jail(); //temporary solution
		}
		else
			parent::onHitObject(%this, %player, %slot, %col, %pos, %normal);
	}
	
	function player::damage(%this, %attacker, %pos, %damage, %damageType)
	{
		%attackerClient = %attacker.client;
		%client = %this.client;
		
		if(isObject(%client))
		{
			if(!%this.isIncapacitated)
			{
				%health = (%this.getdatablock().maxdamage - %this.getdamagelevel()) - %damage;
				
				if(isObject(%attackerClient) && isObject(%attacker) && %attackerClient != %client && mfloor(%health) > 0)
				{
					if(mfloor(%health) < 10)
						%attackerClient.LifeRP_AddCrime(200, "Attempted Murder");
					else
						%attackerClient.LifeRP_AddCrime(mfloor(%damage), "Violence");
				}
				
				if(mfloor(%health) < 10)
					%client.incapacitate(%this, %health);
			}
		}
		
		parent::damage(%this, %attacker, %pos, %damage, %damageType);
	}
	
	function LifeRP_IncapacitatedPlayerArmor::onAdd(%this, %obj)
	{
		%obj.playthread(0, death1);
		parent::onAdd(%this, %obj);
	}
	
	function serverCmdUseTool(%this, %val)
	{
		if(!isObject(%player = %this.player))
			return;
		
		if(%player.isIncapacitated)
		{
			%this.centerPrint("\c6You cannot use items while incapacitated.", 3);
			return;
		}
		
		Parent::serverCmdUseTool(%this, %val);
	}
	
	function LifeRP_IncapacitatedPlayerArmor::onMount(%this, %player, %vehicle, %d, %e, %f)
	{
		if(%player.ispilot() && %player.isIncapacitated)
		{
			Armor::DoDismount(%player.getdatablock(), %player);
			return;
		}
		
		Parent::onMount(%this, %player, %vehicle, %d, %e, %f);
	}
	
	function serverCmdSuicide(%this)
	{
		%player = %this.player;
		
		if(isObject(%player))
		{
			if(!%player.isIncapacitated)
				%this.incapacitate(%player, 95);
			else
				Parent::serverCmdSuicide(%this);
		}
		else
			Parent::serverCmdSuicide(%this);
	}
	
	function gameConnection::onDeath(%this, %killerPlayer, %killer, %damageType, %a)
	{
		parent::onDeath(%this, %killerPlayer, %killer, %damageType, %a);
		
		if(isObject(%killer) && isObject(%killerPlayer) && %killer != %this)
		{
			if(%killerPlayer.getDatablock().getName() $= "deathVehicle")
				return;
			
			%killer.LifeRP_AddCrime(400, "Murder");
		}
	}
};
activatePackage(GameModeLifeRPCrimePackage);