///////////
//Startup//
///////////

function LifeRP_addAllEvents()
{
	//despite the function name, we are also removing some events
	unRegisterInputEvent("fxDTSBrick", "onMiniGameReset"); //there is no need to reset the minigame for lifeRP/pointless event
	unRegisterOutputEvent("fxDTSBrick", "radiusImpulse"); //launching players/abusable with relays/can create invisible barriers/nobody uses it
	
	unRegisterOutputEvent("gameConnection", "incScore"); //liferp does not use minigame score/cant even use this to abuse/totally useless for those reasons
	unRegisterOutputEvent("gameConnection", "bottomPrint"); //liferp's hud is on bottom print/would be pointless to use it
	
	unRegisterOutputEvent("MiniGame", "bottomPrintAll"); //liferp's hud is on bottom print/would be pointless to use it
	unRegisterOutputEvent("MiniGame", "reset"); //there is no need to reset the minigame for lifeRP/pointless event
	
	//and making some admin only
	registerAdminOnlyOutputEvent("fxDTSBrick", "setItem", 1); //free items
	registerAdminOnlyOutputEvent("fxDTSBrick", "spawnExplosion", 1); //abusable with relays/can kill players
	registerAdminOnlyOutputEvent("fxDTSBrick", "spawnItem", 1); //abusable with relays/free items
	registerAdminOnlyOutputEvent("fxDTSBrick", "spawnProjectile", 1); //abusable with relays/can kill players
	
	registerAdminOnlyOutputEvent("Bot", "dropItem", 1); //free items
	registerAdminOnlyOutputEvent("Bot", "setTeam", 1); //can kill players
	registerAdminOnlyOutputEvent("Bot", "spawnExplosion", 1); //can kill players
	registerAdminOnlyOutputEvent("Bot", "spawnProjectile", 1); //can kill players
	
	registerAdminOnlyOutputEvent("Player", "addHealth", 1); //can kill players
	registerAdminOnlyOutputEvent("Player", "changeDatablock", 1); //cheaty
	registerAdminOnlyOutputEvent("Player", "instantRespawn", 1); //respawns players
	registerAdminOnlyOutputEvent("Player", "kill", 1); //kills players
	registerAdminOnlyOutputEvent("Player", "setHealth", 1); //can kill players
	registerAdminOnlyOutputEvent("Player", "spawnExplosion", 1); //can kill players
	registerAdminOnlyOutputEvent("Player", "spawnProjectile", 1); //can kill players
	
	registerAdminOnlyOutputEvent("MiniGame", "centerPrintAll", 1); //abusable
	registerAdminOnlyOutputEvent("MiniGame", "chatMsgAll", 1); //abusable
	registerAdminOnlyOutputEvent("MiniGame", "respawnAll", 1); //respawns all players
	registerAdminOnlyOutputEvent("MiniGame", "setCameraBrick", 1); //abusable
	registerAdminOnlyOutputEvent("MiniGame", "setCameraNormal", 1); //abusable
	
	//let's add our own events now
	registerOutputEvent("gameConnection", "LifeRP_ShowHelp", "string 50 150");
	registerOutputEvent("gameConnection", "LifeRP_ShowRules");
	registerOutputEvent("gameConnection", "LifeRP_ShowCredits");
	
	registerInputEvent("fxDtsBrick", "onLifeRPScoreCheckPass", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerInputEvent("fxDtsBrick", "onLifeRPScoreCheckFail", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerOutputEvent("gameConnection", "LifeRP_AddScore", "int -999999 999999 1" TAB "string 100 200");
	registerOutputEvent("fxDtsBrick", "LifeRP_checkHasScore", "int -999999 999999 0", true);
	
	registerInputEvent("fxDtsBrick", "onLifeRPJobCheckPass", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerInputEvent("fxDtsBrick", "onLifeRPJobCheckFail", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerOutputEvent("gameConnection", "LifeRP_ListJobs");
	registerOutputEvent("gameConnection", "LifeRP_displayJobInfo", "string 50 150");
	registerOutputEvent("gameConnection", "LifeRP_GetJob", "string 50 150");
	registerOutputEvent("gameConnection", "LifeRP_AddQuota", "int -999999 999999 1" TAB "string 100 200");
	registerOutputEvent("fxDtsBrick", "LifeRP_checkHasJob", "string 50 150", true);
	
	registerInputEvent("fxDtsBrick", "onLifeRPCrimeCheckPass", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerInputEvent("fxDtsBrick", "onLifeRPCrimeCheckFail", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerOutputEvent("gameConnection", "LifeRP_AddCrime", "int -999999 999999 1" TAB "string 100 200");
	registerOutputEvent("fxDtsBrick", "LifeRP_checkHasCrime", "int -999999 999999 0", true);
	
	registerInputEvent("fxDtsBrick", "onLifeRPInJailCheckPass", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerInputEvent("fxDtsBrick", "onLifeRPInJailCheckFail", "Self fxDtsBrick" TAB "Player player" TAB "Client gameConnection" TAB "Minigame minigame");
	registerOutputEvent("gameConnection", "LifeRP_Jail");
	registerOutputEvent("fxDtsBrick", "LifeRP_checkInJail", "", true);
	
	//we gotta make some of our events admin only too
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_ShowHelp", 1); //spam potential
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_ShowRules", 1); //spam potential
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_ShowCredits", 1); //spam potential
	
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_AddScore", 1); //free money
	
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_ListJobs", 1); //spam potential
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_DisplayJobInfo", 1); //spam potential
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_GetJob", 1); //spam potential
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_AddQuota", 1); //free quota = free money
	
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_AddCrime", 1); //free... crime?
	registerAdminOnlyOutputEvent("gameConnection", "LifeRP_Jail", 1); //free... jail?
}

/////////////////
//Simple Events//
/////////////////

function gameConnection::LifeRP_ShowHelp(%this, %topic)
{
	serverCmdHelp(%this, %topic);
}

function gameConnection::LifeRP_ShowRules(%this)
{
	serverCmdRules(%this);
}

function gameConnection::LifeRP_ShowCredits(%this)
{
	serverCmdCredits(%this);
}

function gameConnection::LifeRP_ListJobs(%this)
{
	serverCmdJobs(%this);
}

function gameConnection::LifeRP_GetJob(%this, %job)
{
	%this.LifeRPTemp_Job = %job;
	
	if(%job $= "none" || %job $= "quit")
		%message = "Do you want to quit your current job?";
	else if(isObject($LifeRP_job[%job]))
		%message = "Do you want to get the job \"" @ $LifeRP_job[%job].name @ "\"?<br>You will quit your current job.";
	else
	{
		serverCmdJobs(%this);
		return;
	}
	
	commandToClient(%this, 'messageBoxYesNo', "Get Job Event", %message, 'GetJob');
}

///////////
//Package//
///////////

if(isPackage(GameModeLifeRPEventsPackage))
	deactivatePackage(GameModeLifeRPEventsPackage);
package GameModeLifeRPEventsPackage
{
	////////
	//Bots//
	////////
	
	function AIPlayer::playGesture(%obj, %list)
	{
		if($holeBotGestures[%list] $= "attack") //we don't want bots to kill players
			$holeBotGestures[%list] = "activate";

		Parent::playGesture(%obj, %list);
	}
	
	//////////
	//Camera//
	//////////
	
	function GameConnection::setCameraBrick(%this, %posBrickName, %targetBrickName)
	{
		Parent::setCameraBrick(%this, %posBrickName, %targetBrickName);
		%this.centerPrint("<just:right>\c6Toggle your light to return.", 10);
	}
	
	function serverCmdLight(%client, %a)
	{
		%client.setCameraNormal();
		Parent::serverCmdLight(%client, %a);
	}
	
	/////////
	//Items//
	/////////
	
	function fxDTSBrick::setItem(%this, %datablock, %client)
	{
		if(!isObject(%this.item) || %this.item.getDatablock() != %datablock)
		{
			if(isObject(%owner = getBrickGroupFromObject(%this).client) && %owner.isAdmin)
				parent::setItem(%this, %datablock, %client);
		}
		else
			parent::setItem(%this, %datablock, %client);
	}
	
	function fxDTSBrick::spawnItem(%this, %pos, %datablock, %client)
	{
		if(isObject(%owner = getBrickGroupFromObject(%this).client) && %owner.isAdmin)
			parent::spawnItem(%this, %pos, %datablock, %client);
	}
};
activatePackage(GameModeLifeRPEventsPackage);