if(isFile("config/server/LifeRP/prefs.cs"))
	exec("config/server/LifeRP/prefs.cs");

if(mfloor($LifeRP::Pref::DefaultsHaveBeenSet) <= 0)
	deleteVariables("$LifeRP::Pref::*");

//////////////
//Time Prefs//
//////////////

$LifeRP::Pref::TickLength::Help = "TickLength controls how long in miliseconds one ingame minute is.";
if($LifeRP::Pref::TickLength $= "")
	$LifeRP::Pref::TickLength = 500; //default - half a second
else if(mfloor($LifeRP::Pref::TickLength) < 100)
	$LifeRP::Pref::TickLength = 100; //minimum - tenth of a second
else if(mfloor($LifeRP::Pref::TickLength) > 60000)
	$LifeRP::Pref::TickLength = 60000; //maximum - a whole minute

$LifeRP::Pref::ShowADYear::Help = "ShowADYear toggles if you want AD to appear in full dates.";
if($LifeRP::Pref::ShowADYear $= "" || mfloor($LifeRP::Pref::ShowADYear) < 0)
	$LifeRP::Pref::ShowADYear = false; //default - disabled
if(mfloor($LifeRP::Pref::ShowADYear) > 1)
	$LifeRP::Pref::ShowADYear = true;

$LifeRP::Pref::ShowBCYear::Help = "ShowBCYear toggles if you want BC to appear in full dates.";
if($LifeRP::Pref::ShowBCYear $= "" || mfloor($LifeRP::Pref::ShowBCYear) > 1)
	$LifeRP::Pref::ShowBCYear = true; //default - enabled
if(mfloor($LifeRP::Pref::ShowBCYear) < 0)
	$LifeRP::Pref::ShowBCYear = false;

$LifeRP::Pref::UseCEAndBCE::Help = "UseCEAndBCE toggles if you want to use the Common Era abbreviations (CE BCE) instead of the Anno Domini abbreviations (AD BC). https://en.wikipedia.org/wiki/Common_Era";
if($LifeRP::Pref::UseCEAndBCE $= "" || mfloor($LifeRP::Pref::UseCEAndBCE) < 0)
	$LifeRP::Pref::UseCEAndBCE = false; //default - disabled
if(mfloor($LifeRP::Pref::UseCEAndBCE) > 1)
	$LifeRP::Pref::UseCEAndBCE = true;

//////////////
//Chat Prefs//
//////////////

$LifeRP::Pref::RPNames::Help = "RPNames allows toggling of RP names and nicknames. Disabling will force players to appear as their username in RPChat.";
if($LifeRP::Pref::RPNames $= "" || mfloor($LifeRP::Pref::RPNames) > 1)
	$LifeRP::Pref::RPNames = true; //default - enabled
if(mfloor($LifeRP::Pref::RPNames) < 0)
	$LifeRP::Pref::RPNames = false;

$LifeRP::Pref::RPChat::Help = "RPChat allows toggling of the RP chat system.";
if($LifeRP::Pref::RPChat $= "" || mfloor($LifeRP::Pref::RPChat) > 1)
	$LifeRP::Pref::RPChat = true; //default - enabled
if(mfloor($LifeRP::Pref::RPChat) < 0)
	$LifeRP::Pref::RPChat = false;

$LifeRP::Pref::TeamChatIsOOC::Help = "TeamChatIsOOC lets you toggle if team chat will be used to send out of character messages. Disabling will result in normal chat being used as OOC chat.";
if($LifeRP::Pref::TeamChatIsOOC $= "" || mfloor($LifeRP::Pref::TeamChatIsOOC) > 1)
	$LifeRP::Pref::TeamChatIsOOC = true; //default - enabled
if(mfloor($LifeRP::Pref::TeamChatIsOOC) < 0)
	$LifeRP::Pref::TeamChatIsOOC = false;

$LifeRP::Pref::OOCAdminTags::Help = "OOCAdminTags allows you to toggle the tiny admin tags in ooc chat.";
if($LifeRP::Pref::OOCAdminTags $= "" || mfloor($LifeRP::Pref::OOCAdminTags) > 1)
	$LifeRP::Pref::OOCAdminTags = true; //default - enabled
if(mfloor($LifeRP::Pref::OOCAdminTags) < 0)
	$LifeRP::Pref::OOCAdminTags = false;

///////////////
//Score Prefs//
///////////////

$LifeRP::Pref::ScoreName::Help = "ScoreName allows you to name the score/currency.";
if($LifeRP::Pref::ScoreName $= "")
	$LifeRP::Pref::ScoreName = "Money";

$LifeRP::Pref::ScoreNamePlural::Help = "ScoreNamePlural allows you to set the name of the currency when used plurally.";
if($LifeRP::Pref::ScoreNamePlural $= "")
	$LifeRP::Pref::ScoreNamePlural = "Dollars";

$LifeRP::Pref::ScoreNameSingle::Help = "ScoreNameSingle allows you to set the name of the currency when used singularly.";
if($LifeRP::Pref::ScoreNameSingle $= "")
	$LifeRP::Pref::ScoreNameSingle = "Dollar";

$LifeRP::Pref::ScorePrefix::Help = "ScorePrefix is used when the currency is expressed in a number.";
if(mfloor($LifeRP::Pref::DefaultsHaveBeenSet) <= 0)
	$LifeRP::Pref::ScorePrefix = "$";

$LifeRP::Pref::ScoreSuffix::Help = "ScoreSuffix is used when the currency is expressed in a number.";
if(mfloor($LifeRP::Pref::DefaultsHaveBeenSet) <= 0)
	$LifeRP::Pref::ScoreSuffix = "";

$LifeRP::Pref::StartingScore::Help = "StartingScore sets the amount of the currency a player starts out with if they havent joined before, or reset.";
if($LifeRP::Pref::StartingScore $= "")
	$LifeRP::Pref::StartingScore = 5000; //default - recommended because people are going to want to be able to build almost instantly.
else if(mfloor($LifeRP::Pref::StartingScore) < 0)
	$LifeRP::Pref::StartingScore = 0; //minimum - recommend you have something that can earn players dough quick.
else if(mfloor($LifeRP::Pref::StartingScore) > 1000000)
	$LifeRP::Pref::StartingScore = 1000000; //maximum - one million dollars! you're pretty cool to try this out but then why have jobs? or do anything?

$LifeRP::Pref::Welfare::Help = "Welfare sets how much players are given free money per day for not having a job or having a job that allows welfare (like the default slacker).";
if($LifeRP::Pref::Welfare $= "")
	$LifeRP::Pref::Welfare = 20; //default
else if(mfloor($LifeRP::Pref::Welfare) < 0)
	$LifeRP::Pref::Welfare = 0; //minimum - why do they deserve free money anyway?
else if(mfloor($LifeRP::Pref::Welfare) > 1000)
	$LifeRP::Pref::Welfare = 1000; //maximum - wow you're really nice! but this may defeat the purpose of jobs...

$LifeRP::Pref::WelfareTime::Help = "WelfareTime sets what hour in the day welfare is given.";
if($LifeRP::Pref::WelfareTime $= "")
	$LifeRP::Pref::WelfareTime = 8; //default
else if(mfloor($LifeRP::Pref::WelfareTime) < 1)
	$LifeRP::Pref::WelfareTime = 1; //minimum
else if(mfloor($LifeRP::Pref::WelfareTime) > 24)
	$LifeRP::Pref::WelfareTime = 24; //maximum

///////////////
//Price Prefs//
///////////////

$LifeRP::Pref::Price16x16::Help = "Price16x16 is how much it costs to place the 16x16 baseplate when put on the ground to start a player's build off.";
if($LifeRP::Pref::Price16x16 $= "")
	$LifeRP::Pref::Price16x16 = 500; //default
else if(mfloor($LifeRP::Pref::Price16x16) < 0)
	$LifeRP::Pref::Price16x16 = 0; //minimum - a true freebuild! better have many other ways to spend money.
else if(mfloor($LifeRP::Pref::Price16x16) > 1000000)
	$LifeRP::Pref::Price16x16 = 1000000; //maximum - wow that must be a really nice city!

$LifeRP::Pref::Price16x32::Help = "Price16x32 is how much it costs to place the 16x32 baseplate when put on the ground to start a player's build off.";
if($LifeRP::Pref::Price16x32 $= "")
	$LifeRP::Pref::Price16x32 = 1000; //default
else if(mfloor($LifeRP::Pref::Price16x32) < 0)
	$LifeRP::Pref::Price16x32 = 0; //minimum
else if(mfloor($LifeRP::Pref::Price16x32) > 1000000)
	$LifeRP::Pref::Price16x32 = 1000000; //maximum

$LifeRP::Pref::Price32x32::Help = "Price32x32 is how much it costs to place the 32x32 baseplate when put on the ground to start a player's build off.";
if($LifeRP::Pref::Price32x32 $= "")
	$LifeRP::Pref::Price32x32 = 2000; //default
else if(mfloor($LifeRP::Pref::Price32x32) < 0)
	$LifeRP::Pref::Price32x32 = 0; //minimum
else if(mfloor($LifeRP::Pref::Price32x32) > 1000000)
	$LifeRP::Pref::Price32x32 = 1000000; //maximum

$LifeRP::Pref::Price48x48::Help = "Price48x48 is how much it costs to place the 48x48 baseplate when put on the ground to start a player's build off.";
if($LifeRP::Pref::Price48x48 $= "")
	$LifeRP::Pref::Price48x48 = 4500; //default
else if(mfloor($LifeRP::Pref::Price48x48) < 0)
	$LifeRP::Pref::Price48x48 = 0; //minimum
else if(mfloor($LifeRP::Pref::Price48x48) > 1000000)
	$LifeRP::Pref::Price48x48 = 1000000; //maximum

$LifeRP::Pref::Price64x64::Help = "Price64x64 is how much it costs to place the 64x64 baseplate when put on the ground to start a player's build off.";
if($LifeRP::Pref::Price64x64 $= "")
	$LifeRP::Pref::Price64x64 = 8000; //default
else if(mfloor($LifeRP::Pref::Price64x64) < 0)
	$LifeRP::Pref::Price64x64 = 0; //minimum
else if(mfloor($LifeRP::Pref::Price64x64) > 1000000)
	$LifeRP::Pref::Price64x64 = 1000000; //maximum

$LifeRP::Pref::BaseplateReturnMultiplier::Help = "BaseplateReturnMultiplier is multiplied by the baseplate prices and given back to the player when their baseplate is destroyed.";
if($LifeRP::Pref::BaseplateReturnMultiplier $= "")
	$LifeRP::Pref::BaseplateReturnMultiplier = "1.0";

///////////////
//Crime Prefs//
///////////////

$LifeRP::Pref::CrimeNamePlural::Help = "CrimeNamePlural sets the name of the crime units when used plurally.";
if($LifeRP::Pref::CrimeNamePlural $= "")
	$LifeRP::Pref::CrimeNamePlural = "Demerits";

$LifeRP::Pref::CrimeNameSingle::Help = "CrimeNameSingle sets the name of the crime units when used singularry.";
if($LifeRP::Pref::CrimeNameSingle $= "")
	$LifeRP::Pref::CrimeNameSingle = "Demerit";

$LifeRP::Pref::JailName::Help = "JailName sets the name of the jail.";
if($LifeRP::Pref::JailName $= "")
	$LifeRP::Pref::JailName = "Prison";

$LifeRP::Pref::DefaultsHaveBeenSet::Help = "DefaultsHaveBeenSet is set to true after all the prefs have been set to their defaults. Set it to false to reset all of the prefs.";
$LifeRP::Pref::DefaultsHaveBeenSet = true;
		
export("$LifeRP::Pref::*", "config/server/LifeRP/prefs.cs");