/////////
//Ticks//
/////////

function LifeRP_Tick() //special function for the tick, just so we can do weird tick-specific things
{
	cancel($LifeRP::Tick);
	
	LifeRP_doMinute();
	if(isObject(DayCycle) && DayCycle.dayLength >= 86400)
		LifeRP_syncDayCycle(); //this enables a neat feature - the daycycle will sync with the lifeRP time! as long as you set the daycycle to the maximum possible in the gui
	
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%client = $DefaultMinigame.member[%a];
		%client.LifeRP_applyHud();
		
		if(isObject(%client.player) && $LifeRP::Pref::RPChat)
			%client.player.setShapeNameDistance();
	}
	
	$LifeRP::Tick = schedule($LifeRP::Pref::TickLength, 0, LifeRP_Tick);
}

//////////
//Minute//
//////////

function LifeRP_doMinute() //adds a minute to the LifeRP clock - the core of all time in the gamemode
{
	%minute = mfloor($LifeRP_TimeMinute); //make sure it's a number
	%minute++; //add to it
	
	if(%minute >= 60 || %minute < 0)
	{
		%minute = 0; //reset the minute timer - it's a new hour.
		LifeRP_doHour();
	}
	
	$LifeRP_TimeMinute = mfloor(%minute);
}

////////
//Hour//
////////

function LifeRP_doHour() //the hour makes most of the stuff happen to players
{
	%hour = mfloor($LifeRP_TimeHour);
	%hour++;
	
	if(%hour >= 24 || %hour < 0)
	{
		%hour = 0;
		LifeRP_doDay();
	}
	
	$LifeRP_TimeHour = mfloor(%hour);
	%hour = mfloor($LifeRP_TimeHour);
	
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%client = $DefaultMinigame.member[%a];
		%blid = %client.bl_id;
		
		if(mfloor($LifeRP_Player[%blid, "Jail"]) > 0) //everything that happens to people in jail
		{
			$LifeRP_Player[%blid, "Jail"] -= 10;
			%timeJail = mfloor($LifeRP_Player[%blid, "Jail"] / 10);
			
			if(%timeJail > 1)
				%client.centerPrint("<just:right>\c6You have " @ %timeJail @ " hours left in " @ $LifeRP::Pref::JailName @ ".", 10);
			else if(%timeJail >= 1)
				%client.centerPrint("<just:right>\c6You have " @ %timeJail @ " hour left in " @ $LifeRP::Pref::JailName @ ".", 10);
			else
			{
				$LifeRP_Player[%blid, "Jail"] = 0;
				%client.spawnPlayer();
				%client.centerPrint("<just:right>\c6You were released from " @ $LifeRP::Pref::JailName @ ".", 10);
				messageAll('', "\c3" @ %client.LifeRP_GetRPName() @ "\c6 was released from " @ $LifeRP::Pref::JailName @ ".");
			}
		}
		else //everything that happens to everyone else
		{
			%client.LifeRP_AddCrime(-1);
			
			%jobid = $LifeRP_Player[%blid, "Job"];
			%jobid = $LifeRP_job[%jobid].id;
			
			if(!isObject($LifeRP_job[%jobid]) || $LifeRP_job[%jobid].welfare)
			{
				if(%hour == $LifeRP::Pref::WelfareTime)
					%client.LifeRP_AddScore(20, "Welfare");
				if(!isObject($LifeRP_job[%jobid]))
					return;
			}
			
			%jobLevel = mfloor($LifeRP_Player[%blid, "JobLevel", %jobid]);
			
			%paycheckStart = mfloor($LifeRP_job[%jobid].paycheckStart);
			%paycheckEnd = mfloor($LifeRP_job[%jobid].paycheckEnd);
			
			%paycheck = mfloor($LifeRP_job[%jobid].paycheck + %jobLevel);
			%paycheckExtra = mfloor($LifeRP_job[%jobid].paycheckExtra + %jobLevel);
			
			%paycheckOvertime = mfloor($LifeRP_job[%jobid].paycheckOvertime);
			if(%paycheckOvertime > 0)
				%paycheckOvertime = mfloor($LifeRP_job[%jobid].paycheckOvertime + %jobLevel);
			
			%quota = mfloor($LifeRP_job[%jobid].quota);
			if(%quota > 0)
				%quota = mfloor($LifeRP_job[%jobid].quota + %jobLevel);
			
			%quotaExtra = mfloor($LifeRP_job[%jobid].quotaExtra);
			if(%quotaExtra > 0)
				%quotaExtra = mfloor($LifeRP_job[%jobid].quotaExtra + (%jobLevel * 2));
			
			%repBonus = mfloor($LifeRP_job[%jobid].repBonus);
			%repLevel = mfloor($LifeRP_job[%jobid].repLevel * (%jobLevel + 1));
			
			if(%paycheck > 0)
			{
				if(%client.LifeRP_Quota >= %quota)
				{
					if(%hour >= %paycheckStart && %hour <= %paycheckEnd)
					{
						if(%client.LifeRP_Quota >= %quotaExtra && %quotaExtra > %quota)
						{
							$LifeRP_Player[%blid, "JobRep", %jobid] += %repBonus;
							%client.LifeRP_AddScore(%paycheckExtra, "Bonus Paycheck");
							
							if($LifeRP_Player[%blid, "JobRep", %jobid] >= %repLevel)
							{
								$LifeRP_Player[%blid, "JobLevel", %jobid]++;
								%client.chatMessage("\c2You just got promoted!<br>\c2You will be paid one dollar more, but have to work more.<br>\c2Congrats.");
							}
						}
						else
						{
							$LifeRP_Player[%blid, "JobRep", %jobid]++;
							%client.LifeRP_AddScore(%paycheck, "Paycheck");
						}
					}
					else if(%paycheckOvertime > 0)
						%client.LifeRP_AddScore(%paycheckOvertime, "Overtime Paycheck");
				}
				else if(%quota > 0)
				{
					if(%hour >= %paycheckStart && %hour <= %paycheckEnd)
						%client.chatMessage("\c0You were not paid because you did not meet your quota.", 10);
					else if(%hour == %paycheckStart - 1)
						%client.chatMessage("\c3You should be working now.", 10);
					else if(%hour == %paycheckStart - 2)
						%client.chatMessage("\c3You should really start getting ready to work.", 10);
				}
			}
		}
		
		%client.LifeRP_AddHunger(9);
		%client.LifeRP_AddThirst(15);
		
		%client.LifeRP_Quota = 0;
		export("$LifeRP_Player" @ %blid @ "_*", "config/server/LifeRP/playersaves/" @ %blid @ ".cs");
	}
}

///////
//Day//
///////
function LifeRP_doDay()
{
	%day = mfloor($LifeRP_TimeDay);
	%day++;
	
	if(%day > LifeRP_daysInMonth() || %day <= 0)
	{
		%day = 1;
		LifeRP_doMonth();
	}
	
	$LifeRP_TimeDay = mfloor(%day);
	%day = mfloor($LifeRP_TimeDay);
	
	echo("A day has passed. Saving time data.");
	export("$LifeRP_Time*", "config/server/LifeRP/time.cs");
	
	messageAll('', "\c6 - It is now " @ LifeRP_getDate(0) @ ".");
	
	%month = mfloor($LifeRP_TimeMonth);
	
	if(isObject($LifeRP_month[%month]))
	{
		if($LifeRP_month[%month].message[%day] !$= "")
		messageAll('', "\c6 - " @ $LifeRP_month[%month].message[%day]);
	}
}

/////////
//Month//
/////////

function LifeRP_doMonth()
{
	%month = mfloor($LifeRP_TimeMonth);
	%month++;
	
	//if(%month >= 12 || %month <= 0)
	if(!isObject($LifeRP_month[%month]))
	{
		%month = 1;
		LifeRP_doYear();
	}
	
	$LifeRP_TimeMonth = mfloor(%month);
}

//scriptobjects
function LifeRP_addAllMonths()
{
	LifeRP_addMonthFromFile("january");
	LifeRP_addMonthFromFile("february");
	LifeRP_addMonthFromFile("march");
	LifeRP_addMonthFromFile("april");
	LifeRP_addMonthFromFile("may");
	LifeRP_addMonthFromFile("june");
	LifeRP_addMonthFromFile("july");
	LifeRP_addMonthFromFile("august");
	LifeRP_addMonthFromFile("september");
	LifeRP_addMonthFromFile("october");
	LifeRP_addMonthFromFile("november");
	LifeRP_addMonthFromFile("december");
}

function LifeRP_addMonthFromFile(%file)
{
	if(isFile("Add-Ons/GameMode_LifeRP/months/" @ %file @ ".cs"))
	{
		exec("Add-Ons/GameMode_LifeRP/months/" @ %file @ ".cs");
		$LifeRP::temp::month::id = mfloor($LifeRP::temp::month::id);
		
		if($LifeRP::temp::month::id <= 0)
		{
			echo("ERROR: No or invalid ID found for" @ %file @ ".cs.");
			deleteVariables("$LifeRP::temp::month::*");
			return;
		}
		
		if(isObject($LifeRP_month[$LifeRP::temp::month::id]))
		{
			echo("ERROR: $LifeRP_month" @ $LifeRP::temp::month::id @ " already exists.");
			deleteVariables("$LifeRP::temp::month::*");
			return;
		}
		
		$LifeRP_month[$LifeRP::temp::month::id] = new scriptObject()
		{
			id			= $LifeRP::temp::month::id; //controls when the month is - make sure this is a number.
			name		= $LifeRP::temp::month::name; //month name example: "January"
			shortName	= $LifeRP::temp::month::shortName; //short month name example: "Jan"
			
			days		= $LifeRP::temp::month::days; //amount of days in the month
			leapDays	= $LifeRP::temp::month::leapDays; //amount of days in the month during a leap year
			
			message1	= $LifeRP::temp::month::message1; //message to be played on that day of the month
			message2	= $LifeRP::temp::month::message2; //these can be used for holidays
			message3	= $LifeRP::temp::month::message3;
			message4	= $LifeRP::temp::month::message4;
			message5	= $LifeRP::temp::month::message5;
			message6	= $LifeRP::temp::month::message6;
			message7	= $LifeRP::temp::month::message7;
			message8	= $LifeRP::temp::month::message8;
			message9	= $LifeRP::temp::month::message9;
			message10	= $LifeRP::temp::month::message10;
			message11	= $LifeRP::temp::month::message11;
			message12	= $LifeRP::temp::month::message12;
			message13	= $LifeRP::temp::month::message13;
			message14	= $LifeRP::temp::month::message14;
			message15	= $LifeRP::temp::month::message15;
			message16	= $LifeRP::temp::month::message16;
			message17	= $LifeRP::temp::month::message17;
			message18	= $LifeRP::temp::month::message18;
			message19	= $LifeRP::temp::month::message19;
			message20	= $LifeRP::temp::month::message20;
			message21	= $LifeRP::temp::month::message21;
			message22	= $LifeRP::temp::month::message22;
			message23	= $LifeRP::temp::month::message23;
			message24	= $LifeRP::temp::month::message24;
			message25	= $LifeRP::temp::month::message25;
			message26	= $LifeRP::temp::month::message26;
			message27	= $LifeRP::temp::month::message27;
			message28	= $LifeRP::temp::month::message28;
			message29	= $LifeRP::temp::month::message29;
			message30	= $LifeRP::temp::month::message30;
			message31	= $LifeRP::temp::month::message31; //just add more of these if you seriously want months with a crazy high amount of days with holidays on those days - this will probably be made more adaptable
		};
		
		if(isObject($LifeRP_month[$LifeRP::temp::month::id]))
		{
			echo("$LifeRP_month" @ $LifeRP::temp::month::id @ " sucessfully added.");
			deleteVariables("$LifeRP::temp::month::*");
			return;
		}
		else
		{
			echo("ERROR: $LifeRP_month" @ $LifeRP::temp::month::id @ " could not be added for some reason.");
			deleteVariables("$LifeRP::temp::month::*");
			return;
		}
	}
}

////////
//Year//
////////

function LifeRP_doYear()
{
	%year = mfloor($LifeRP_TimeYear);
	%year++;
	
	if(%year == 0) //there is no year zero, year 1AD/CE is after 1BC/BCE
		%year = 1;
	
	$LifeRP_TimeYear = mfloor(%year);
	
	if(LifeRP_isLeapYear(%year))
		messageAll('', "\c6 - This year is a leap year!");
}

///////////////
//Checks/Gets//
///////////////

function LifeRP_daysInMonth(%month, %year) //gets how many days are in the month provided
{
	if(%month $= "")
		%month = mfloor($LifeRP_TimeMonth);
	if(%year $= "")
		%year = mfloor($LifeRP_TimeYear);
	
	%month = mfloor(%month);
	%year = mfloor(%year);
	
	if(isObject($LifeRP_month[%month]))
	{
		if(LifeRP_isLeapYear(%year))
			%days = $LifeRP_month[%month].leapDays;
		else
			%days = $LifeRP_month[%month].days;
	}
	
	if(%days $= "")
		%days = 1;
	
	return %days;
}

function LifeRP_isLeapYear(%year) //checks if the year provided is a leap year
{
	if(%year $= "")
		%year = mfloor($LifeRP_TimeYear);
	
	%year = mfloor(%year);
	//In the Gregorian calendar 3 criteria must be taken into account to identify leap years:
	if((%year / 4) == mfloor(%year / 4)) //The year is evenly divisible by 4;
	{
		if((%year / 100) == mfloor(%year / 100)) //If the year can be evenly divided by 100, it is NOT a leap year, unless;
		{
			if((%year / 400) == mfloor(%year / 400)) //The year is also evenly divisible by 400. Then it is a leap year.
				return true;
			else
				return false;
		}
		else
			return true;
	}
	else
		return false;
	//http://www.timeanddate.com/date/leapyear.html
}

function LifeRP_getMonthName(%month) //gets a string containing the name of the month provided
{
	if(%month $= "")
		%month = mfloor($LifeRP_TimeMonth);
	
	%month = mfloor(%month);
	
	if(isObject($LifeRP_month[%month]))
		%monthName = $LifeRP_month[%month].name;
	
	if(%monthName $= "")
		%monthName = "Error";
	
	return %monthName;
}

function LifeRP_getTimeString(%type, %minute, %hour) //gets a string containing the time
{
	if(%minute $= "")
		%minute = mfloor($LifeRP_TimeMinute);
	if(%hour $= "")
		%hour = mfloor($LifeRP_TimeHour);
	
	%type = mfloor(%type);
	%minute = mfloor(%minute);
	%hour = mfloor(%hour);
	
	if(%type <= 0) //24 hour clock
		%timeString = %hour @ ":" @ %minute;
	else if(%type == 1) //12 hour clock
	{
		if(%hour < 12)
			%suffix = "AM";
		else if(%hour >= 12)
			%suffix = "PM";
		
		if(%hour <= 0)
			%hour += 12;
		else if(%hour > 12)
			%hour -= 12;
		
		if(%minute < 10)
			%minute = "0" @ %minute;
		
		%timeString = %hour @ ":" @ %minute SPC %suffix;
	}
	else if(%type == 2) //12 hour only clock
	{
		if(%hour < 12)
			%suffix = "AM";
		else if(%hour >= 12)
			%suffix = "PM";
		
		if(%hour <= 0)
			%hour += 12;
		else if(%hour > 12)
			%hour -= 12;
		
		%timeString = %hour @ %suffix;
	}
	
	return %timeString;
}

function LifeRP_getDate(%type, %year, %month, %day) //gets a string containing a date
{
	if(%year $= "")
		%year = mfloor($LifeRP_TimeYear);
	if(%month $= "")
		%month = mfloor($LifeRP_TimeMonth);
	if(%day $= "")
		%day = mfloor($LifeRP_TimeDay);
	
	%type = mfloor(%type);
	%year = mfloor(%year);
	%month = mfloor(%month);
	%day = mfloor(%day);
	
	if(%type <= 0) //Month Day, Year
	{
		%month = LifeRP_getMonthName(%month);
		
		if(%day == 1 || %day == 21 || %day == 31)
			%day = %day @ "st";
		else if(%day == 2 || %day == 22 || %day == 32)
			%day = %day @ "nd";
		else if(%day == 3 || %day == 23)
			%day = %day @ "rd";
		else
			%day = %day @ "th";
		
		if($LifeRP::Pref::UseCEAndBCE = true)
		{
			if(%year > 0 && $LifeRP::Pref::ShowADYear == true)
				%year = %year SPC "AD";
			else if(%year < 0 && $LifeRP::Pref::ShowBCYear == true)
				%year = (%year * -1) SPC "BC";
		}
		else if($LifeRP::Pref::UseCEAndBCE = false)
		{
			if(%year > 0 && $LifeRP::Pref::ShowADYear == true)
				%year = %year SPC "CE";
			else if(%year < 0 && $LifeRP::Pref::ShowBCYear == true)
				%year = (%year * -1) SPC "BCE";
		}
		
		%dateString = %month SPC %day @ ", " @ %year;
	}
	else if(%type >= 1) //Month Day
	{
		%month = LifeRP_getMonthName(%month);
		
		if(%day == 1 || %day == 21 || %day == 31)
			%day = %day @ "st";
		else if(%day == 2 || %day == 22)
			%day = %day @ "nd";
		else if(%day == 3 || %day == 23)
			%day = %day @ "rd";
		else
			%day = %day @ "th";
		
		%dateString = %month SPC %day;
	}
	
	return %dateString;
}

function LifeRP_syncDayCycle() //based on port's code sniplet
{
	if(!isObject(DayCycle))
		return;

	if(DayCycle.dayLength < 86400)
		return;

	%time = (mfloor($LifeRP_TimeHour) * 3600) + (mfloor($LifeRP_TimeMinute) * 60);
	%time -= 20600;
	if(%time < 0)
		%time += DayCycle.dayLength;
	
	DayCycle.setDayOffset(%time / DayCycle.dayLength);
}

////////////
//Commands//
////////////

function serverCmdSkip(%client, %time, %amount, %bc)
{
	if(!%client.isAdmin)
		return;
	
	if(%time !$= "year" && %time !$= "month" && %time !$= "day" && %time !$= "hour" && %time !$= "minute")
		%time = "minute";
	
	if(%amount $= "")
		%amount = -1;
	%amount = mfloor(%amount);
	
	if(%time $= "year" || %time $= "month" || %time $= "day" || %time $= "hour")
		$LifeRP_TimeMinute = 999;
	if(%time $= "year" || %time $= "month" || %time $= "day")
		$LifeRP_TimeHour = 999;
	if(%time $= "year" || %time $= "month")
		$LifeRP_TimeDay = 999;
	if(%time $= "year")
		$LifeRP_TimeMonth = 999;
	
	if(%time $= "minute" && %amount < 60 && %amount >= 0)
	{
		$LifeRP_TimeMinute = %amount - 1;
		%client.chatMessage("\c3" @ %client.name @ " skipped to " @ LifeRP_getTimeString(1, %amount, mfloor($LifeRP_TimeHour)) @ ".");
	}
	else if(%time $= "hour" && %amount < 24 && %amount >= 0)
	{
		$LifeRP_TimeHour = %amount - 1;
		%client.chatMessage("\c3" @ %client.name @ " skipped to " @ LifeRP_getTimeString(1, 0, %amount) @ ".");
	}
	else if(%time $= "day" && %amount <= LifeRP_daysInMonth() && %amount > 0)
	{
		$LifeRP_TimeDay = %amount - 1;
		%client.chatMessage("\c3" @ %client.name @ " skipped to day " @ %amount @ ".");
	}
	else if(%time $= "month" && isObject($LifeRP_month[%amount]))
	{
		$LifeRP_TimeMonth = %amount - 1;
		%client.chatMessage("\c3" @ %client.name @ " skipped to month " @ LifeRP_getMonthName(%amount) @ ".");
	}
	else if(%time $= "year" && %amount > 0)
	{
		if(%bc $= "bc" || %bc $= "bce")
		{
			$LifeRP_TimeYear = (%amount * -1) - 1;
			%client.chatMessage("\c3" @ %client.name @ " skipped to year " @ %amount SPC %bc @ ".");
		}
		else
		{
			$LifeRP_TimeYear = %amount - 1;
			%client.chatMessage("\c3" @ %client.name @ " skipped to year " @ %amount @ ".");
		}
	}
	else
		%client.chatMessage("\c3" @ %client.name @ " skipped the current " @ %time @ ".");
	
	LifeRP_Tick();
}